darcs

Issue 2361 optimize --reorder runs forever with one repository

Title optimize --reorder runs forever with one repository
Priority Status resolved
Milestone Resolved in 2.10.0 HEAD
Superseder Nosy List alex.aegf, gh
Assigned To alex.aegf
Topics Performance

Created on 2014-03-14.13:49:19 by gh, last changed 2014-06-05.21:58:17 by noreply.

Messages
msg17209 (view) Author: gh Date: 2014-03-14.13:49:18
1. Summarise the issue (what were doing, what went wrong?)

Running `optimize --reorder` seems to never end on this repository (let
it run for 2 hours and it did not finish).

Here is the problematic repository:

https://dl.dropboxusercontent.com/u/6239815/FORENSIC.opt.reorder.120min.reviewed.tar.gz
 (< 48 MBytes)


2. What behaviour were you expecting instead?

Taking a reasonable amount of time to run, and also report progress
(currently `optimize --reorder` is silent save for the last output message).

3. Version used

Darcs 2.9.8 

4. What operating system are you running?

Ubuntu Linux 14.04
msg17498 (view) Author: gh Date: 2014-05-30.20:39:54
Ale and I saw that the call to 'removeFromUnrevertContext' from the
function 'tentativelyReplacePatches' called by 'optimize --reorder' was
the source of the problem.

We are going to fix the issue by not updating anymore the unrevert patch
when reordering history (since reordering does not remove any patch in
the end, the unrevert patch will always be appliable).

However it will be good to see why 'removeFromUnrevertContext' is
choking on this particular case, even after this ticket is closed.
msg17524 (view) Author: gh Date: 2014-06-05.19:45:39
Uploaded a smaller (7 Mbytes) version of the forensic repo:

https://dl.dropboxusercontent.com/u/6239815/forensic2.tar.lzma

Download, uncompress, rebuild pristine (darcs repair) then run optimize
reorder before and after patch1169.
msg17529 (view) Author: noreply Date: 2014-06-05.21:58:16
The following patch sent by Ale Gadea <alex.aegf@gmail.com> updated issue Issue2361 with
status=resolved;resolvedin=2.10.0 HEAD

* Resolve Issue2361: optimize --reorder runs forever with one repository 
Ignore-this: b18bc37e5d6668df62f05679c629e08c
History
Date User Action Args
2014-03-14 13:49:19ghcreate
2014-03-14 13:49:56ghsettopic: + Performance
2014-03-17 00:50:14ghsetassignedto: alex.aegf
nosy: + alex.aegf
2014-05-30 20:39:56ghsetmessages: + msg17498
2014-06-05 19:45:40ghsetmessages: + msg17524
2014-06-05 21:58:17noreplysetstatus: unknown -> resolved
messages: + msg17529
resolvedin: 2.10.0 HEAD